/* ======================================================================== *\
!
! *
! * This file is part of MARS, the MAGIC Analysis and Reconstruction
! * Software. It is distributed to you in the hope that it can be a useful
! * and timesaving tool in analysing Data of imaging Cerenkov telescopes.
! * It is distributed WITHOUT ANY WARRANTY.
! *
! * Permission to use, copy, modify and distribute this software and its
! * documentation for any purpose is hereby granted without fee,
! * provided that the above copyright notice appear in all copies and
! * that both that copyright notice and this permission notice appear
! * in supporting documentation. It is provided "as is" without express
! * or implied warranty.
! *
!
!
!   Author(s): Thomas Bretz  12/2000 <mailto:tbretz@uni-sw.gwdg.de>
!
!   Copyright: MAGIC Software Development, 2000-2001
!
!
\* ======================================================================== */

/////////////////////////////////////////////////////////////////////////////
//
// MPedPhotPix
//
// This is the storage container to hold informations about the pedestal
// (offset) value of one Pixel (PMT) in units of photons
//
/////////////////////////////////////////////////////////////////////////////
#include "MPedPhotPix.h"

#include "MLog.h"

ClassImp(MPedPhotPix);

MPedPhotPix::MPedPhotPix()
{
    Clear();
}

// ------------------------------------------------------------------------
//
// Invalidate values
//
void MPedPhotPix::Clear(Option_t *o)
{
    fMean = -1;
    fRms  = -1;
}

